diff a/make/modules/jdk.compiler/Gensrc.gmk b/make/modules/jdk.compiler/Gensrc.gmk
--- a/make/modules/jdk.compiler/Gensrc.gmk
+++ b/make/modules/jdk.compiler/Gensrc.gmk
@@ -1,7 +1,7 @@
 #
-# Copyright (c) 2014, 2022, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2014, 2024, Oracle and/or its affiliates. All rights reserved.
 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 #
 # This code is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License version 2 only, as
 # published by the Free Software Foundation.  Oracle designates this
@@ -70,5 +70,28 @@
     OUTPUT_DIR := $(SUPPORT_OUTPUTDIR)/gensrc/$(MODULE), \
     COMMAND := $(TOOL_PARSEPROPERTIES_CMD) $(PARSEPROPERTIES_ARGS), \
 ))
 
 TARGETS += $(PARSEPROPERTIES)
+
+################################################################################
+#
+# Copy stubs of code reflection API in langtools
+
+GENSTUBS_DEST_ROOT := $(SUPPORT_OUTPUTDIR)/gensrc/$(MODULE)
+
+GENSTUBS_SRC := $(TOPDIR)/src/java.base/share/classes/java/lang/reflect/code
+
+GENSTUBS_DEST := $(GENSTUBS_DEST_ROOT)/jdk/internal/java/lang/reflect/code
+
+GENSTUBS_SCRIPT := $(TOPDIR)/cr-util/copy-to-compiler.sh
+
+GENSTUBS_CMD := $(BASH) $(GENSTUBS_SCRIPT) $(TOPDIR)/src/java.base/share/classes $(GENSTUBS_DEST_ROOT)
+
+$(eval $(call SetupExecute, GENSTUBS, \
+    WARN := Generating compiler stubs for code reflection, \
+    DEPS := $(call FindFiles, $(GENSTUBS_SRC), *.java), \
+    OUTPUT_DIR := $(GENSTUBS_DEST), \
+    COMMAND := $(GENSTUBS_CMD), \
+))
+
+TARGETS += $(GENSTUBS)
